package in.benchresources.normal.loan.approval.service;

import in.benchresources.entities.loan.ProcessLoanRequestType;
import in.benchresources.entities.loan.ProcessLoanResponseType;
import in.benchresources.services.defaultloanapprovalservice.IDefaultLoanApprovalService;

import javax.jws.WebService;

@WebService(serviceName="DefaultLoanApprovalService", endpointInterface="in.benchresources.services.defaultloanapprovalservice.IDefaultLoanApprovalService",
targetNamespace="http://benchresources.in/services/DefaultLoanApprovalService/", portName="DefaultLoanApprovalServicePort", name="DefaultLoanApprovalServiceImpl")
public class DefaultLoanApprovalServiceImpl implements IDefaultLoanApprovalService {

	// http://localhost:8080/EmployeeLoanService/services/DefaultLoanApprovalService?wsdl - Apache Tomcat 7.x

	public ProcessLoanResponseType processEmployeeLoan(ProcessLoanRequestType parameters) {

		System.out.println("DefaultLoanApprovalServiceImpl>>Id : " + ">>" + parameters.getEmployeeId() + "<<");
		System.out.println("DefaultLoanApprovalServiceImpl>>Name : " + ">>" + parameters.getEmployeeName() + "<<");
		System.out.println("DefaultLoanApprovalServiceImpl>>Grade : " + ">>" + parameters.getEmployeeGrade() + "<<");
		System.out.println("DefaultLoanApprovalServiceImpl>>Amount : " + ">>" + parameters.getAmountInDollars() + "<<");
		System.out.println("DefaultLoanApprovalServiceImpl>>Validated : " + ">>" + parameters.getEmployeeDetailValidated() + "<<");
		System.out.println("DefaultLoanApprovalServiceImpl>>Comments : " + ">>" + parameters.getComments() + "<<");

		// create object response type and SET values based on the below "employeeDetailValidated" parameter
		ProcessLoanResponseType processLoanResponseType = null;

		if(null != parameters && "Yes".equalsIgnoreCase(parameters.getEmployeeDetailValidated().toString())) {

			System.out.println("DefaultLoanApprovalServiceImpl>> Not null case");

			processLoanResponseType = new ProcessLoanResponseType();
			processLoanResponseType.setEmployeeId(parameters.getEmployeeId());
			processLoanResponseType.setEmployeeName(parameters.getEmployeeName());
			processLoanResponseType.setEmployeeGrade(parameters.getEmployeeGrade());
			processLoanResponseType.setAmountInDollars(parameters.getAmountInDollars());
			processLoanResponseType.setResponseMessage("Loan Approved for amount LESS than 4K dollars");
		}
		else {

			System.out.println("DefaultLoanApprovalServiceImpl>> null case");

			processLoanResponseType = new ProcessLoanResponseType();
			processLoanResponseType.setEmployeeId(parameters.getEmployeeId());
			processLoanResponseType.setEmployeeName(parameters.getEmployeeName());
			processLoanResponseType.setEmployeeGrade(parameters.getEmployeeGrade());
			processLoanResponseType.setAmountInDollars(parameters.getAmountInDollars());
			processLoanResponseType.setResponseMessage("Loan Rejected: Employee details validation fails");
		}

		// finally return response type setting approval/rejection message with brief description
		return processLoanResponseType;
	}
}